# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP Audits Domain Types"""

from enum import Enum
from typing import List
from typing_extensions import NotRequired, TypedDict

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from ..dom.types import BackendNodeId
    from ..network.types import ClientSecurityState
    from ..network.types import CorsErrorStatus
    from ..network.types import IPAddressSpace
    from ..network.types import LoaderId
    from ..network.types import RequestId
    from ..page.types import FrameId
    from ..runtime.types import ScriptId

"""Information about a cookie that is affected by an inspector issue."""
class AffectedCookie(TypedDict):
    name: "str"
    """The following three properties uniquely identify a cookie"""
    path: "str"
    domain: "str"



"""Information about a request that is affected by an inspector issue."""
class AffectedRequest(TypedDict):
    requestId: "NotRequired[RequestId]"
    """The unique request id."""
    url: "str"



"""Information about the frame affected by an inspector issue."""
class AffectedFrame(TypedDict):
    frameId: "FrameId"



class CookieExclusionReason(Enum):
    EXCLUDESAMESITEUNSPECIFIEDTREATEDASLAX = "ExcludeSameSiteUnspecifiedTreatedAsLax"
    EXCLUDESAMESITENONEINSECURE = "ExcludeSameSiteNoneInsecure"
    EXCLUDESAMESITELAX = "ExcludeSameSiteLax"
    EXCLUDESAMESITESTRICT = "ExcludeSameSiteStrict"
    EXCLUDEINVALIDSAMEPARTY = "ExcludeInvalidSameParty"
    EXCLUDESAMEPARTYCROSSPARTYCONTEXT = "ExcludeSamePartyCrossPartyContext"
    EXCLUDEDOMAINNONASCII = "ExcludeDomainNonASCII"
    EXCLUDETHIRDPARTYCOOKIEBLOCKEDINFIRSTPARTYSET = "ExcludeThirdPartyCookieBlockedInFirstPartySet"
    EXCLUDETHIRDPARTYPHASEOUT = "ExcludeThirdPartyPhaseout"
    EXCLUDEPORTMISMATCH = "ExcludePortMismatch"
    EXCLUDESCHEMEMISMATCH = "ExcludeSchemeMismatch"



class CookieWarningReason(Enum):
    WARNSAMESITEUNSPECIFIEDCROSSSITECONTEXT = "WarnSameSiteUnspecifiedCrossSiteContext"
    WARNSAMESITENONEINSECURE = "WarnSameSiteNoneInsecure"
    WARNSAMESITEUNSPECIFIEDLAXALLOWUNSAFE = "WarnSameSiteUnspecifiedLaxAllowUnsafe"
    WARNSAMESITESTRICTLAXDOWNGRADESTRICT = "WarnSameSiteStrictLaxDowngradeStrict"
    WARNSAMESITESTRICTCROSSDOWNGRADESTRICT = "WarnSameSiteStrictCrossDowngradeStrict"
    WARNSAMESITESTRICTCROSSDOWNGRADELAX = "WarnSameSiteStrictCrossDowngradeLax"
    WARNSAMESITELAXCROSSDOWNGRADESTRICT = "WarnSameSiteLaxCrossDowngradeStrict"
    WARNSAMESITELAXCROSSDOWNGRADELAX = "WarnSameSiteLaxCrossDowngradeLax"
    WARNATTRIBUTEVALUEEXCEEDSMAXSIZE = "WarnAttributeValueExceedsMaxSize"
    WARNDOMAINNONASCII = "WarnDomainNonASCII"
    WARNTHIRDPARTYPHASEOUT = "WarnThirdPartyPhaseout"
    WARNCROSSSITEREDIRECTDOWNGRADECHANGESINCLUSION = "WarnCrossSiteRedirectDowngradeChangesInclusion"
    WARNDEPRECATIONTRIALMETADATA = "WarnDeprecationTrialMetadata"
    WARNTHIRDPARTYCOOKIEHEURISTIC = "WarnThirdPartyCookieHeuristic"



class CookieOperation(Enum):
    SETCOOKIE = "SetCookie"
    READCOOKIE = "ReadCookie"



"""Represents the category of insight that a cookie issue falls under."""
class InsightType(Enum):
    GITHUBRESOURCE = "GitHubResource"
    GRACEPERIOD = "GracePeriod"
    HEURISTICS = "Heuristics"



"""Information about the suggested solution to a cookie issue."""
class CookieIssueInsight(TypedDict):
    type: "InsightType"
    tableEntryUrl: "NotRequired[str]"
    """Link to table entry in third-party cookie migration readiness list."""



"""This information is currently necessary, as the front-end has a difficult
time finding a specific cookie. With this, we can convey specific error
information without the cookie."""
class CookieIssueDetails(TypedDict):
    cookie: "NotRequired[AffectedCookie]"
    """If AffectedCookie is not set then rawCookieLine contains the raw
Set-Cookie header string. This hints at a problem where the
cookie line is syntactically or semantically malformed in a way
that no valid cookie could be created."""
    rawCookieLine: "NotRequired[str]"
    cookieWarningReasons: "List[CookieWarningReason]"
    cookieExclusionReasons: "List[CookieExclusionReason]"
    operation: "CookieOperation"
    """Optionally identifies the site-for-cookies and the cookie url, which
may be used by the front-end as additional context."""
    siteForCookies: "NotRequired[str]"
    cookieUrl: "NotRequired[str]"
    request: "NotRequired[AffectedRequest]"
    insight: "NotRequired[CookieIssueInsight]"
    """The recommended solution to the issue."""



class MixedContentResolutionStatus(Enum):
    MIXEDCONTENTBLOCKED = "MixedContentBlocked"
    MIXEDCONTENTAUTOMATICALLYUPGRADED = "MixedContentAutomaticallyUpgraded"
    MIXEDCONTENTWARNING = "MixedContentWarning"



class MixedContentResourceType(Enum):
    ATTRIBUTIONSRC = "AttributionSrc"
    AUDIO = "Audio"
    BEACON = "Beacon"
    CSPREPORT = "CSPReport"
    DOWNLOAD = "Download"
    EVENTSOURCE = "EventSource"
    FAVICON = "Favicon"
    FONT = "Font"
    FORM = "Form"
    FRAME = "Frame"
    IMAGE = "Image"
    IMPORT = "Import"
    JSON = "JSON"
    MANIFEST = "Manifest"
    PING = "Ping"
    PLUGINDATA = "PluginData"
    PLUGINRESOURCE = "PluginResource"
    PREFETCH = "Prefetch"
    RESOURCE = "Resource"
    SCRIPT = "Script"
    SERVICEWORKER = "ServiceWorker"
    SHAREDWORKER = "SharedWorker"
    SPECULATIONRULES = "SpeculationRules"
    STYLESHEET = "Stylesheet"
    TRACK = "Track"
    VIDEO = "Video"
    WORKER = "Worker"
    XMLHTTPREQUEST = "XMLHttpRequest"
    XSLT = "XSLT"



class MixedContentIssueDetails(TypedDict):
    resourceType: "NotRequired[MixedContentResourceType]"
    """The type of resource causing the mixed content issue (css, js, iframe,
form,...). Marked as optional because it is mapped to from
blink::mojom::RequestContextType, which will be replaced
by network::mojom::RequestDestination"""
    resolutionStatus: "MixedContentResolutionStatus"
    """The way the mixed content issue is being resolved."""
    insecureURL: "str"
    """The unsafe http url causing the mixed content issue."""
    mainResourceURL: "str"
    """The url responsible for the call to an unsafe url."""
    request: "NotRequired[AffectedRequest]"
    """The mixed content request.
Does not always exist (e.g. for unsafe form submission urls)."""
    frame: "NotRequired[AffectedFrame]"
    """Optional because not every mixed content issue is necessarily linked to a frame."""



"""Enum indicating the reason a response has been blocked. These reasons are
refinements of the net error BLOCKED_BY_RESPONSE."""
class BlockedByResponseReason(Enum):
    COEPFRAMERESOURCENEEDSCOEPHEADER = "CoepFrameResourceNeedsCoepHeader"
    COOPSANDBOXEDIFRAMECANNOTNAVIGATETOCOOPPAGE = "CoopSandboxedIFrameCannotNavigateToCoopPage"
    CORPNOTSAMEORIGIN = "CorpNotSameOrigin"
    CORPNOTSAMEORIGINAFTERDEFAULTEDTOSAMEORIGINBYCOEP = "CorpNotSameOriginAfterDefaultedToSameOriginByCoep"
    CORPNOTSAMEORIGINAFTERDEFAULTEDTOSAMEORIGINBYDIP = "CorpNotSameOriginAfterDefaultedToSameOriginByDip"
    CORPNOTSAMEORIGINAFTERDEFAULTEDTOSAMEORIGINBYCOEPANDDIP = "CorpNotSameOriginAfterDefaultedToSameOriginByCoepAndDip"
    CORPNOTSAMESITE = "CorpNotSameSite"
    SRIMESSAGESIGNATUREMISMATCH = "SRIMessageSignatureMismatch"



"""Details for a request that has been blocked with the BLOCKED_BY_RESPONSE
code. Currently only used for COEP/COOP, but may be extended to include
some CSP errors in the future."""
class BlockedByResponseIssueDetails(TypedDict):
    request: "AffectedRequest"
    parentFrame: "NotRequired[AffectedFrame]"
    blockedFrame: "NotRequired[AffectedFrame]"
    reason: "BlockedByResponseReason"



class HeavyAdResolutionStatus(Enum):
    HEAVYADBLOCKED = "HeavyAdBlocked"
    HEAVYADWARNING = "HeavyAdWarning"



class HeavyAdReason(Enum):
    NETWORKTOTALLIMIT = "NetworkTotalLimit"
    CPUTOTALLIMIT = "CpuTotalLimit"
    CPUPEAKLIMIT = "CpuPeakLimit"



class HeavyAdIssueDetails(TypedDict):
    resolution: "HeavyAdResolutionStatus"
    """The resolution status, either blocking the content or warning."""
    reason: "HeavyAdReason"
    """The reason the ad was blocked, total network or cpu or peak cpu."""
    frame: "AffectedFrame"
    """The frame that was blocked."""



class ContentSecurityPolicyViolationType(Enum):
    KINLINEVIOLATION = "kInlineViolation"
    KEVALVIOLATION = "kEvalViolation"
    KURLVIOLATION = "kURLViolation"
    KSRIVIOLATION = "kSRIViolation"
    KTRUSTEDTYPESSINKVIOLATION = "kTrustedTypesSinkViolation"
    KTRUSTEDTYPESPOLICYVIOLATION = "kTrustedTypesPolicyViolation"
    KWASMEVALVIOLATION = "kWasmEvalViolation"



class SourceCodeLocation(TypedDict):
    scriptId: "NotRequired[ScriptId]"
    url: "str"
    lineNumber: "int"
    columnNumber: "int"



class ContentSecurityPolicyIssueDetails(TypedDict):
    blockedURL: "NotRequired[str]"
    """The url not included in allowed sources."""
    violatedDirective: "str"
    """Specific directive that is violated, causing the CSP issue."""
    isReportOnly: "bool"
    contentSecurityPolicyViolationType: "ContentSecurityPolicyViolationType"
    frameAncestor: "NotRequired[AffectedFrame]"
    sourceCodeLocation: "NotRequired[SourceCodeLocation]"
    violatingNodeId: "NotRequired[BackendNodeId]"



class SharedArrayBufferIssueType(Enum):
    TRANSFERISSUE = "TransferIssue"
    CREATIONISSUE = "CreationIssue"



"""Details for a issue arising from an SAB being instantiated in, or
transferred to a context that is not cross-origin isolated."""
class SharedArrayBufferIssueDetails(TypedDict):
    sourceCodeLocation: "SourceCodeLocation"
    isWarning: "bool"
    type: "SharedArrayBufferIssueType"



class LowTextContrastIssueDetails(TypedDict):
    violatingNodeId: "BackendNodeId"
    violatingNodeSelector: "str"
    contrastRatio: "float"
    thresholdAA: "float"
    thresholdAAA: "float"
    fontSize: "str"
    fontWeight: "str"



"""Details for a CORS related issue, e.g. a warning or error related to
CORS RFC1918 enforcement."""
class CorsIssueDetails(TypedDict):
    corsErrorStatus: "CorsErrorStatus"
    isWarning: "bool"
    request: "AffectedRequest"
    location: "NotRequired[SourceCodeLocation]"
    initiatorOrigin: "NotRequired[str]"
    resourceIPAddressSpace: "NotRequired[IPAddressSpace]"
    clientSecurityState: "NotRequired[ClientSecurityState]"



class AttributionReportingIssueType(Enum):
    PERMISSIONPOLICYDISABLED = "PermissionPolicyDisabled"
    UNTRUSTWORTHYREPORTINGORIGIN = "UntrustworthyReportingOrigin"
    INSECURECONTEXT = "InsecureContext"
    INVALIDHEADER = "InvalidHeader"
    INVALIDREGISTERTRIGGERHEADER = "InvalidRegisterTriggerHeader"
    SOURCEANDTRIGGERHEADERS = "SourceAndTriggerHeaders"
    SOURCEIGNORED = "SourceIgnored"
    TRIGGERIGNORED = "TriggerIgnored"
    OSSOURCEIGNORED = "OsSourceIgnored"
    OSTRIGGERIGNORED = "OsTriggerIgnored"
    INVALIDREGISTEROSSOURCEHEADER = "InvalidRegisterOsSourceHeader"
    INVALIDREGISTEROSTRIGGERHEADER = "InvalidRegisterOsTriggerHeader"
    WEBANDOSHEADERS = "WebAndOsHeaders"
    NOWEBOROSSUPPORT = "NoWebOrOsSupport"
    NAVIGATIONREGISTRATIONWITHOUTTRANSIENTUSERACTIVATION = "NavigationRegistrationWithoutTransientUserActivation"
    INVALIDINFOHEADER = "InvalidInfoHeader"
    NOREGISTERSOURCEHEADER = "NoRegisterSourceHeader"
    NOREGISTERTRIGGERHEADER = "NoRegisterTriggerHeader"
    NOREGISTEROSSOURCEHEADER = "NoRegisterOsSourceHeader"
    NOREGISTEROSTRIGGERHEADER = "NoRegisterOsTriggerHeader"
    NAVIGATIONREGISTRATIONUNIQUESCOPEALREADYSET = "NavigationRegistrationUniqueScopeAlreadySet"



class SharedDictionaryError(Enum):
    USEERRORCROSSORIGINNOCORSREQUEST = "UseErrorCrossOriginNoCorsRequest"
    USEERRORDICTIONARYLOADFAILURE = "UseErrorDictionaryLoadFailure"
    USEERRORMATCHINGDICTIONARYNOTUSED = "UseErrorMatchingDictionaryNotUsed"
    USEERRORUNEXPECTEDCONTENTDICTIONARYHEADER = "UseErrorUnexpectedContentDictionaryHeader"
    WRITEERRORCOSSORIGINNOCORSREQUEST = "WriteErrorCossOriginNoCorsRequest"
    WRITEERRORDISALLOWEDBYSETTINGS = "WriteErrorDisallowedBySettings"
    WRITEERROREXPIREDRESPONSE = "WriteErrorExpiredResponse"
    WRITEERRORFEATUREDISABLED = "WriteErrorFeatureDisabled"
    WRITEERRORINSUFFICIENTRESOURCES = "WriteErrorInsufficientResources"
    WRITEERRORINVALIDMATCHFIELD = "WriteErrorInvalidMatchField"
    WRITEERRORINVALIDSTRUCTUREDHEADER = "WriteErrorInvalidStructuredHeader"
    WRITEERRORNAVIGATIONREQUEST = "WriteErrorNavigationRequest"
    WRITEERRORNOMATCHFIELD = "WriteErrorNoMatchField"
    WRITEERRORNONLISTMATCHDESTFIELD = "WriteErrorNonListMatchDestField"
    WRITEERRORNONSECURECONTEXT = "WriteErrorNonSecureContext"
    WRITEERRORNONSTRINGIDFIELD = "WriteErrorNonStringIdField"
    WRITEERRORNONSTRINGINMATCHDESTLIST = "WriteErrorNonStringInMatchDestList"
    WRITEERRORNONSTRINGMATCHFIELD = "WriteErrorNonStringMatchField"
    WRITEERRORNONTOKENTYPEFIELD = "WriteErrorNonTokenTypeField"
    WRITEERRORREQUESTABORTED = "WriteErrorRequestAborted"
    WRITEERRORSHUTTINGDOWN = "WriteErrorShuttingDown"
    WRITEERRORTOOLONGIDFIELD = "WriteErrorTooLongIdField"
    WRITEERRORUNSUPPORTEDTYPE = "WriteErrorUnsupportedType"



class SRIMessageSignatureError(Enum):
    MISSINGSIGNATUREHEADER = "MissingSignatureHeader"
    MISSINGSIGNATUREINPUTHEADER = "MissingSignatureInputHeader"
    INVALIDSIGNATUREHEADER = "InvalidSignatureHeader"
    INVALIDSIGNATUREINPUTHEADER = "InvalidSignatureInputHeader"
    SIGNATUREHEADERVALUEISNOTBYTESEQUENCE = "SignatureHeaderValueIsNotByteSequence"
    SIGNATUREHEADERVALUEISPARAMETERIZED = "SignatureHeaderValueIsParameterized"
    SIGNATUREHEADERVALUEISINCORRECTLENGTH = "SignatureHeaderValueIsIncorrectLength"
    SIGNATUREINPUTHEADERMISSINGLABEL = "SignatureInputHeaderMissingLabel"
    SIGNATUREINPUTHEADERVALUENOTINNERLIST = "SignatureInputHeaderValueNotInnerList"
    SIGNATUREINPUTHEADERVALUEMISSINGCOMPONENTS = "SignatureInputHeaderValueMissingComponents"
    SIGNATUREINPUTHEADERINVALIDCOMPONENTTYPE = "SignatureInputHeaderInvalidComponentType"
    SIGNATUREINPUTHEADERINVALIDCOMPONENTNAME = "SignatureInputHeaderInvalidComponentName"
    SIGNATUREINPUTHEADERINVALIDHEADERCOMPONENTPARAMETER = "SignatureInputHeaderInvalidHeaderComponentParameter"
    SIGNATUREINPUTHEADERINVALIDDERIVEDCOMPONENTPARAMETER = "SignatureInputHeaderInvalidDerivedComponentParameter"
    SIGNATUREINPUTHEADERKEYIDLENGTH = "SignatureInputHeaderKeyIdLength"
    SIGNATUREINPUTHEADERINVALIDPARAMETER = "SignatureInputHeaderInvalidParameter"
    SIGNATUREINPUTHEADERMISSINGREQUIREDPARAMETERS = "SignatureInputHeaderMissingRequiredParameters"
    VALIDATIONFAILEDSIGNATUREEXPIRED = "ValidationFailedSignatureExpired"
    VALIDATIONFAILEDINVALIDLENGTH = "ValidationFailedInvalidLength"
    VALIDATIONFAILEDSIGNATUREMISMATCH = "ValidationFailedSignatureMismatch"
    VALIDATIONFAILEDINTEGRITYMISMATCH = "ValidationFailedIntegrityMismatch"



"""Details for issues around \"Attribution Reporting API\" usage.
Explainer: https://github.com/WICG/attribution-reporting-api"""
class AttributionReportingIssueDetails(TypedDict):
    violationType: "AttributionReportingIssueType"
    request: "NotRequired[AffectedRequest]"
    violatingNodeId: "NotRequired[BackendNodeId]"
    invalidParameter: "NotRequired[str]"



"""Details for issues about documents in Quirks Mode
or Limited Quirks Mode that affects page layouting."""
class QuirksModeIssueDetails(TypedDict):
    isLimitedQuirksMode: "bool"
    """If false, it means the document's mode is \"quirks\"
instead of \"limited-quirks\"."""
    documentNodeId: "BackendNodeId"
    url: "str"
    frameId: "FrameId"
    loaderId: "LoaderId"



class NavigatorUserAgentIssueDetails(TypedDict):
    url: "str"
    location: "NotRequired[SourceCodeLocation]"



class SharedDictionaryIssueDetails(TypedDict):
    sharedDictionaryError: "SharedDictionaryError"
    request: "AffectedRequest"



class SRIMessageSignatureIssueDetails(TypedDict):
    error: "SRIMessageSignatureError"
    signatureBase: "str"
    integrityAssertions: "List[str]"
    request: "AffectedRequest"



class GenericIssueErrorType(Enum):
    FORMLABELFORNAMEERROR = "FormLabelForNameError"
    FORMDUPLICATEIDFORINPUTERROR = "FormDuplicateIdForInputError"
    FORMINPUTWITHNOLABELERROR = "FormInputWithNoLabelError"
    FORMAUTOCOMPLETEATTRIBUTEEMPTYERROR = "FormAutocompleteAttributeEmptyError"
    FORMEMPTYIDANDNAMEATTRIBUTESFORINPUTERROR = "FormEmptyIdAndNameAttributesForInputError"
    FORMARIALABELLEDBYTONONEXISTINGID = "FormAriaLabelledByToNonExistingId"
    FORMINPUTASSIGNEDAUTOCOMPLETEVALUETOIDORNAMEATTRIBUTEERROR = "FormInputAssignedAutocompleteValueToIdOrNameAttributeError"
    FORMLABELHASNEITHERFORNORNESTEDINPUT = "FormLabelHasNeitherForNorNestedInput"
    FORMLABELFORMATCHESNONEXISTINGIDERROR = "FormLabelForMatchesNonExistingIdError"
    FORMINPUTHASWRONGBUTWELLINTENDEDAUTOCOMPLETEVALUEERROR = "FormInputHasWrongButWellIntendedAutocompleteValueError"
    RESPONSEWASBLOCKEDBYORB = "ResponseWasBlockedByORB"



"""Depending on the concrete errorType, different properties are set."""
class GenericIssueDetails(TypedDict):
    errorType: "GenericIssueErrorType"
    """Issues with the same errorType are aggregated in the frontend."""
    frameId: "NotRequired[FrameId]"
    violatingNodeId: "NotRequired[BackendNodeId]"
    violatingNodeAttribute: "NotRequired[str]"
    request: "NotRequired[AffectedRequest]"



"""This issue tracks information needed to print a deprecation message.
https://source.chromium.org/chromium/chromium/src/+/main:third_party/blink/renderer/core/frame/third_party/blink/renderer/core/frame/deprecation/README.md"""
class DeprecationIssueDetails(TypedDict):
    affectedFrame: "NotRequired[AffectedFrame]"
    sourceCodeLocation: "SourceCodeLocation"
    type: "str"
    """One of the deprecation names from third_party/blink/renderer/core/frame/deprecation/deprecation.json5"""



"""This issue warns about sites in the redirect chain of a finished navigation
that may be flagged as trackers and have their state cleared if they don't
receive a user interaction. Note that in this context 'site' means eTLD+1.
For example, if the URL `https://example.test:80/bounce` was in the
redirect chain, the site reported would be `example.test`."""
class BounceTrackingIssueDetails(TypedDict):
    trackingSites: "List[str]"



"""This issue warns about third-party sites that are accessing cookies on the
current page, and have been permitted due to having a global metadata grant.
Note that in this context 'site' means eTLD+1. For example, if the URL
`https://example.test:80/web_page` was accessing cookies, the site reported
would be `example.test`."""
class CookieDeprecationMetadataIssueDetails(TypedDict):
    allowedSites: "List[str]"
    optOutPercentage: "float"
    isOptOutTopLevel: "bool"
    operation: "CookieOperation"



class ClientHintIssueReason(Enum):
    METATAGALLOWLISTINVALIDORIGIN = "MetaTagAllowListInvalidOrigin"
    METATAGMODIFIEDHTML = "MetaTagModifiedHTML"



class FederatedAuthRequestIssueDetails(TypedDict):
    federatedAuthRequestIssueReason: "FederatedAuthRequestIssueReason"



"""Represents the failure reason when a federated authentication reason fails.
Should be updated alongside RequestIdTokenStatus in
third_party/blink/public/mojom/devtools/inspector_issue.mojom to include
all cases except for success."""
class FederatedAuthRequestIssueReason(Enum):
    SHOULDEMBARGO = "ShouldEmbargo"
    TOOMANYREQUESTS = "TooManyRequests"
    WELLKNOWNHTTPNOTFOUND = "WellKnownHttpNotFound"
    WELLKNOWNNORESPONSE = "WellKnownNoResponse"
    WELLKNOWNINVALIDRESPONSE = "WellKnownInvalidResponse"
    WELLKNOWNLISTEMPTY = "WellKnownListEmpty"
    WELLKNOWNINVALIDCONTENTTYPE = "WellKnownInvalidContentType"
    CONFIGNOTINWELLKNOWN = "ConfigNotInWellKnown"
    WELLKNOWNTOOBIG = "WellKnownTooBig"
    CONFIGHTTPNOTFOUND = "ConfigHttpNotFound"
    CONFIGNORESPONSE = "ConfigNoResponse"
    CONFIGINVALIDRESPONSE = "ConfigInvalidResponse"
    CONFIGINVALIDCONTENTTYPE = "ConfigInvalidContentType"
    CLIENTMETADATAHTTPNOTFOUND = "ClientMetadataHttpNotFound"
    CLIENTMETADATANORESPONSE = "ClientMetadataNoResponse"
    CLIENTMETADATAINVALIDRESPONSE = "ClientMetadataInvalidResponse"
    CLIENTMETADATAINVALIDCONTENTTYPE = "ClientMetadataInvalidContentType"
    IDPNOTPOTENTIALLYTRUSTWORTHY = "IdpNotPotentiallyTrustworthy"
    DISABLEDINSETTINGS = "DisabledInSettings"
    DISABLEDINFLAGS = "DisabledInFlags"
    ERRORFETCHINGSIGNIN = "ErrorFetchingSignin"
    INVALIDSIGNINRESPONSE = "InvalidSigninResponse"
    ACCOUNTSHTTPNOTFOUND = "AccountsHttpNotFound"
    ACCOUNTSNORESPONSE = "AccountsNoResponse"
    ACCOUNTSINVALIDRESPONSE = "AccountsInvalidResponse"
    ACCOUNTSLISTEMPTY = "AccountsListEmpty"
    ACCOUNTSINVALIDCONTENTTYPE = "AccountsInvalidContentType"
    IDTOKENHTTPNOTFOUND = "IdTokenHttpNotFound"
    IDTOKENNORESPONSE = "IdTokenNoResponse"
    IDTOKENINVALIDRESPONSE = "IdTokenInvalidResponse"
    IDTOKENIDPERRORRESPONSE = "IdTokenIdpErrorResponse"
    IDTOKENCROSSSITEIDPERRORRESPONSE = "IdTokenCrossSiteIdpErrorResponse"
    IDTOKENINVALIDREQUEST = "IdTokenInvalidRequest"
    IDTOKENINVALIDCONTENTTYPE = "IdTokenInvalidContentType"
    ERRORIDTOKEN = "ErrorIdToken"
    CANCELED = "Canceled"
    RPPAGENOTVISIBLE = "RpPageNotVisible"
    SILENTMEDIATIONFAILURE = "SilentMediationFailure"
    THIRDPARTYCOOKIESBLOCKED = "ThirdPartyCookiesBlocked"
    NOTSIGNEDINWITHIDP = "NotSignedInWithIdp"
    MISSINGTRANSIENTUSERACTIVATION = "MissingTransientUserActivation"
    REPLACEDBYACTIVEMODE = "ReplacedByActiveMode"
    INVALIDFIELDSSPECIFIED = "InvalidFieldsSpecified"
    RELYINGPARTYORIGINISOPAQUE = "RelyingPartyOriginIsOpaque"
    TYPENOTMATCHING = "TypeNotMatching"
    UIDISMISSEDNOEMBARGO = "UiDismissedNoEmbargo"
    CORSERROR = "CorsError"
    SUPPRESSEDBYSEGMENTATIONPLATFORM = "SuppressedBySegmentationPlatform"



class FederatedAuthUserInfoRequestIssueDetails(TypedDict):
    federatedAuthUserInfoRequestIssueReason: "FederatedAuthUserInfoRequestIssueReason"



"""Represents the failure reason when a getUserInfo() call fails.
Should be updated alongside FederatedAuthUserInfoRequestResult in
third_party/blink/public/mojom/devtools/inspector_issue.mojom."""
class FederatedAuthUserInfoRequestIssueReason(Enum):
    NOTSAMEORIGIN = "NotSameOrigin"
    NOTIFRAME = "NotIframe"
    NOTPOTENTIALLYTRUSTWORTHY = "NotPotentiallyTrustworthy"
    NOAPIPERMISSION = "NoApiPermission"
    NOTSIGNEDINWITHIDP = "NotSignedInWithIdp"
    NOACCOUNTSHARINGPERMISSION = "NoAccountSharingPermission"
    INVALIDCONFIGORWELLKNOWN = "InvalidConfigOrWellKnown"
    INVALIDACCOUNTSRESPONSE = "InvalidAccountsResponse"
    NORETURNINGUSERFROMFETCHEDACCOUNTS = "NoReturningUserFromFetchedAccounts"



"""This issue tracks client hints related issues. It's used to deprecate old
features, encourage the use of new ones, and provide general guidance."""
class ClientHintIssueDetails(TypedDict):
    sourceCodeLocation: "SourceCodeLocation"
    clientHintIssueReason: "ClientHintIssueReason"



class FailedRequestInfo(TypedDict):
    url: "str"
    """The URL that failed to load."""
    failureMessage: "str"
    """The failure message for the failed request."""
    requestId: "NotRequired[RequestId]"



class PartitioningBlobURLInfo(Enum):
    BLOCKEDCROSSPARTITIONFETCHING = "BlockedCrossPartitionFetching"
    ENFORCENOOPENERFORNAVIGATION = "EnforceNoopenerForNavigation"



class PartitioningBlobURLIssueDetails(TypedDict):
    url: "str"
    """The BlobURL that failed to load."""
    partitioningBlobURLInfo: "PartitioningBlobURLInfo"
    """Additional information about the Partitioning Blob URL issue."""



class ElementAccessibilityIssueReason(Enum):
    DISALLOWEDSELECTCHILD = "DisallowedSelectChild"
    DISALLOWEDOPTGROUPCHILD = "DisallowedOptGroupChild"
    NONPHRASINGCONTENTOPTIONCHILD = "NonPhrasingContentOptionChild"
    INTERACTIVECONTENTOPTIONCHILD = "InteractiveContentOptionChild"
    INTERACTIVECONTENTLEGENDCHILD = "InteractiveContentLegendChild"
    INTERACTIVECONTENTSUMMARYDESCENDANT = "InteractiveContentSummaryDescendant"



"""This issue warns about errors in the select or summary element content model."""
class ElementAccessibilityIssueDetails(TypedDict):
    nodeId: "BackendNodeId"
    elementAccessibilityIssueReason: "ElementAccessibilityIssueReason"
    hasDisallowedAttributes: "bool"



class StyleSheetLoadingIssueReason(Enum):
    LATEIMPORTRULE = "LateImportRule"
    REQUESTFAILED = "RequestFailed"



"""This issue warns when a referenced stylesheet couldn't be loaded."""
class StylesheetLoadingIssueDetails(TypedDict):
    sourceCodeLocation: "SourceCodeLocation"
    """Source code position that referenced the failing stylesheet."""
    styleSheetLoadingIssueReason: "StyleSheetLoadingIssueReason"
    """Reason why the stylesheet couldn't be loaded."""
    failedRequestInfo: "NotRequired[FailedRequestInfo]"
    """Contains additional info when the failure was due to a request."""



class PropertyRuleIssueReason(Enum):
    INVALIDSYNTAX = "InvalidSyntax"
    INVALIDINITIALVALUE = "InvalidInitialValue"
    INVALIDINHERITS = "InvalidInherits"
    INVALIDNAME = "InvalidName"



"""This issue warns about errors in property rules that lead to property
registrations being ignored."""
class PropertyRuleIssueDetails(TypedDict):
    sourceCodeLocation: "SourceCodeLocation"
    """Source code position of the property rule."""
    propertyRuleIssueReason: "PropertyRuleIssueReason"
    """Reason why the property rule was discarded."""
    propertyValue: "NotRequired[str]"
    """The value of the property rule property that failed to parse"""



class UserReidentificationIssueType(Enum):
    BLOCKEDFRAMENAVIGATION = "BlockedFrameNavigation"
    BLOCKEDSUBRESOURCE = "BlockedSubresource"



"""This issue warns about uses of APIs that may be considered misuse to
re-identify users."""
class UserReidentificationIssueDetails(TypedDict):
    type: "UserReidentificationIssueType"
    request: "NotRequired[AffectedRequest]"
    """Applies to BlockedFrameNavigation and BlockedSubresource issue types."""



"""A unique identifier for the type of issue. Each type may use one of the
optional fields in InspectorIssueDetails to convey more specific
information about the kind of issue."""
class InspectorIssueCode(Enum):
    COOKIEISSUE = "CookieIssue"
    MIXEDCONTENTISSUE = "MixedContentIssue"
    BLOCKEDBYRESPONSEISSUE = "BlockedByResponseIssue"
    HEAVYADISSUE = "HeavyAdIssue"
    CONTENTSECURITYPOLICYISSUE = "ContentSecurityPolicyIssue"
    SHAREDARRAYBUFFERISSUE = "SharedArrayBufferIssue"
    LOWTEXTCONTRASTISSUE = "LowTextContrastIssue"
    CORSISSUE = "CorsIssue"
    ATTRIBUTIONREPORTINGISSUE = "AttributionReportingIssue"
    QUIRKSMODEISSUE = "QuirksModeIssue"
    PARTITIONINGBLOBURLISSUE = "PartitioningBlobURLIssue"
    NAVIGATORUSERAGENTISSUE = "NavigatorUserAgentIssue"
    GENERICISSUE = "GenericIssue"
    DEPRECATIONISSUE = "DeprecationIssue"
    CLIENTHINTISSUE = "ClientHintIssue"
    FEDERATEDAUTHREQUESTISSUE = "FederatedAuthRequestIssue"
    BOUNCETRACKINGISSUE = "BounceTrackingIssue"
    COOKIEDEPRECATIONMETADATAISSUE = "CookieDeprecationMetadataIssue"
    STYLESHEETLOADINGISSUE = "StylesheetLoadingIssue"
    FEDERATEDAUTHUSERINFOREQUESTISSUE = "FederatedAuthUserInfoRequestIssue"
    PROPERTYRULEISSUE = "PropertyRuleIssue"
    SHAREDDICTIONARYISSUE = "SharedDictionaryIssue"
    ELEMENTACCESSIBILITYISSUE = "ElementAccessibilityIssue"
    SRIMESSAGESIGNATUREISSUE = "SRIMessageSignatureIssue"
    USERREIDENTIFICATIONISSUE = "UserReidentificationIssue"



"""This struct holds a list of optional fields with additional information
specific to the kind of issue. When adding a new issue code, please also
add a new optional field to this type."""
class InspectorIssueDetails(TypedDict, total=False):
    cookieIssueDetails: "CookieIssueDetails"
    mixedContentIssueDetails: "MixedContentIssueDetails"
    blockedByResponseIssueDetails: "BlockedByResponseIssueDetails"
    heavyAdIssueDetails: "HeavyAdIssueDetails"
    contentSecurityPolicyIssueDetails: "ContentSecurityPolicyIssueDetails"
    sharedArrayBufferIssueDetails: "SharedArrayBufferIssueDetails"
    lowTextContrastIssueDetails: "LowTextContrastIssueDetails"
    corsIssueDetails: "CorsIssueDetails"
    attributionReportingIssueDetails: "AttributionReportingIssueDetails"
    quirksModeIssueDetails: "QuirksModeIssueDetails"
    partitioningBlobURLIssueDetails: "PartitioningBlobURLIssueDetails"
    navigatorUserAgentIssueDetails: "NavigatorUserAgentIssueDetails"
    genericIssueDetails: "GenericIssueDetails"
    deprecationIssueDetails: "DeprecationIssueDetails"
    clientHintIssueDetails: "ClientHintIssueDetails"
    federatedAuthRequestIssueDetails: "FederatedAuthRequestIssueDetails"
    bounceTrackingIssueDetails: "BounceTrackingIssueDetails"
    cookieDeprecationMetadataIssueDetails: "CookieDeprecationMetadataIssueDetails"
    stylesheetLoadingIssueDetails: "StylesheetLoadingIssueDetails"
    propertyRuleIssueDetails: "PropertyRuleIssueDetails"
    federatedAuthUserInfoRequestIssueDetails: "FederatedAuthUserInfoRequestIssueDetails"
    sharedDictionaryIssueDetails: "SharedDictionaryIssueDetails"
    elementAccessibilityIssueDetails: "ElementAccessibilityIssueDetails"
    sriMessageSignatureIssueDetails: "SRIMessageSignatureIssueDetails"
    userReidentificationIssueDetails: "UserReidentificationIssueDetails"



"""A unique id for a DevTools inspector issue. Allows other entities (e.g.
exceptions, CDP message, console messages, etc.) to reference an issue."""
IssueId = str



"""An inspector issue reported from the back-end."""
class InspectorIssue(TypedDict):
    code: "InspectorIssueCode"
    details: "InspectorIssueDetails"
    issueId: "NotRequired[IssueId]"
    """A unique id for this issue. May be omitted if no other entity (e.g.
exception, CDP message, etc.) is referencing this issue."""
