# This file is auto-generated by the CDP protocol generator.
# Do not edit this file manually as your changes will be overwritten.
# Generated from Chrome DevTools Protocol specifications.

"""CDP BluetoothEmulation Domain Types"""

from enum import Enum
from typing import List
from typing_extensions import TypedDict

"""Indicates the various states of Central."""
class CentralState(Enum):
    ABSENT = "absent"
    POWERED_OFF = "powered-off"
    POWERED_ON = "powered-on"



"""Indicates the various types of GATT event."""
class GATTOperationType(Enum):
    CONNECTION = "connection"
    DISCOVERY = "discovery"



"""Indicates the various types of characteristic write."""
class CharacteristicWriteType(Enum):
    WRITE_DEFAULT_DEPRECATED = "write-default-deprecated"
    WRITE_WITH_RESPONSE = "write-with-response"
    WRITE_WITHOUT_RESPONSE = "write-without-response"



"""Indicates the various types of characteristic operation."""
class CharacteristicOperationType(Enum):
    READ = "read"
    WRITE = "write"
    SUBSCRIBE_TO_NOTIFICATIONS = "subscribe-to-notifications"
    UNSUBSCRIBE_FROM_NOTIFICATIONS = "unsubscribe-from-notifications"



"""Indicates the various types of descriptor operation."""
class DescriptorOperationType(Enum):
    READ = "read"
    WRITE = "write"



"""Stores the manufacturer data"""
class ManufacturerData(TypedDict):
    key: "int"
    """Company identifier
https://bitbucket.org/bluetooth-SIG/public/src/main/assigned_numbers/company_identifiers/company_identifiers.yaml
https://usb.org/developers"""
    data: "str"
    """Manufacturer-specific data (Encoded as a base64 string when passed over JSON)"""



"""Stores the byte data of the advertisement packet sent by a Bluetooth device."""
class ScanRecord(TypedDict, total=False):
    name: "str"
    uuids: "List[str]"
    appearance: "int"
    """Stores the external appearance description of the device."""
    txPower: "int"
    """Stores the transmission power of a broadcasting device."""
    manufacturerData: "List[ManufacturerData]"
    """Key is the company identifier and the value is an array of bytes of
manufacturer specific data."""



"""Stores the advertisement packet information that is sent by a Bluetooth device."""
class ScanEntry(TypedDict):
    deviceAddress: "str"
    rssi: "int"
    scanRecord: "ScanRecord"



"""Describes the properties of a characteristic. This follows Bluetooth Core
Specification BT 4.2 Vol 3 Part G 3.3.1. Characteristic Properties."""
class CharacteristicProperties(TypedDict, total=False):
    broadcast: "bool"
    read: "bool"
    writeWithoutResponse: "bool"
    write: "bool"
    notify: "bool"
    indicate: "bool"
    authenticatedSignedWrites: "bool"
    extendedProperties: "bool"
